package projektsystemKerne;
import bjbupack.jdb.*;  
import java.sql.*;  
import java.util.*;  
/**  
  * Klassen til hndtering af Timeforbrug-Objekter i relationel database  
  * @version  Januar 2002 (1.10)
  * @author   DBObjectAdministratorGenerator  
*/  

public class TimeforbrugAdministrator  extends DBObjectAdministrator  
{  
  private  int  lastKey   = 0;     // gemmer til autonummerering 
  public  TimeforbrugAdministrator (DBAdministrator    dbAdministrator,   
                              String table)  
  {  
    super (dbAdministrator, table, "ID","SELECT * FROM "+table);  
    lastKey = getLastKey();    // gemmer til autonummerering  
  }  

  // get-metode med to ngler disables, da objekt er med enkeltngle
  public  Object  get (int key, int key2)
  {
    System.out.println("Fejl: der skal anvendes metode med eet nglerfelt");
    throw new UnsupportedOperationException();
  }

  // contains-metode som checkker om objekt med ngle findes
  public  boolean  contains ( Object object )  
  {  
    Timeforbrug   timeforbrug = (Timeforbrug)object;  
    return get(timeforbrug.getID()) != null;
  }

  // opretter et nyt object p databasen - implementer abstract  
  public  boolean  add ( Object object )
  {  
    Timeforbrug   timeforbrug = (Timeforbrug)object;  
     
    String  SQL_Dato;
    if (timeforbrug.getDato() == null) SQL_Dato = "NULL";
    else SQL_Dato = "'"+timeforbrug.getDato().toString().substring(0,19)+"'";
     
    String sql   = "INSERT INTO "+table  
                + " ("  
                + "  [ID]"  
                + "  ,[Dato]"  
                + "  ,[Timer]"  
                + "  ,[AktivitetID]"  
                + " ) VALUES "  
                + " ("  
                + "  "  +timeforbrug.getID()      +""  
                + ", "  +SQL_Dato
                + ", "  +timeforbrug.getTimer()      +""  
                + ", "  +timeforbrug.getAktivitetID()      +""  
                + " )";  
    return ( executeUpdate (sql) );  
  }  

  // opdaterer et eksisterede object p databasen - implementer abstract  
  public  boolean  replace ( Object object )  
  {  
    Timeforbrug   timeforbrug = (Timeforbrug)object;  
     
    String  SQL_Dato;
    if (timeforbrug.getDato() == null) SQL_Dato = "NULL";
    else SQL_Dato = "'"+timeforbrug.getDato().toString().substring(0,19)+"'";
     
    String sql  = "UPDATE "+table+" SET"  
                + "  [Dato]="  +SQL_Dato
                + ", [Timer]="  +timeforbrug.getTimer()    +""  
                + ", [AktivitetID]="  +timeforbrug.getAktivitetID()    +""  
                + " WHERE [ID]="  +timeforbrug.getID()    +""  
                ;  
    return ( executeUpdate (sql) );  
  }  

  // sletter et object fra dabasen - implementer abstract  
  public  boolean  remove ( Object object )  
  {  
    Timeforbrug   timeforbrug = (Timeforbrug)object;  
    String sql  = "DELETE * FROM "+table  
                + " WHERE [ID]="  +timeforbrug.getID()    +""  
                ;  
    return ( executeUpdate (sql) );  
  }  

  // Konverter fra ResultSet til object - implementer abstract  
  protected  Object  convertToObject (ResultSet resultSet)  
  {  
    try  
    {  
      Timeforbrug   timeforbrug = new Timeforbrug (   resultSet.getInt("ID"),  
                                   resultSet.getTimestamp("Dato"),  
                                   resultSet.getFloat("Timer"),  
                                   resultSet.getInt("AktivitetID")   ); 
      return (timeforbrug);  
    }  
    catch (SQLException e)      
    {  
      System.out.println("Fejl ved convertToObject fra "+table);
      return (null);  
    }  
  }  

  // Ekstra metoder

  // returner et nyt object - skal gemmes p databasen med add  
  // metoden er tilrettet 
  public  Timeforbrug  newTimeforbrug ( Timestamp dato, 
                                        float timer, 
                                        Aktivitet aktivitet )
  {  
    ++lastKey;  
    Timeforbrug timeforbrug = new Timeforbrug ( lastKey, dato, timer, aktivitet );
    return (timeforbrug);  
  }  

  // returner aggregerede timeforbrug til aktivitet
  public Iterator iterator (Aktivitet aktivitet)
  {
    return iterator ("WHERE [AktivitetID] = "+aktivitet.getID());
  }


}  