class PersistensAdministrator
{
  private static DBAdministrator projektsystemDBAdm = new DBAdministrator("Projektsystem");

 // Metode til klargring
  protected  static  void  open ()
  {
    projektsystemDBAdm.open();
  }

  // metode som sikrer tilbageskrivning
  protected  static  void  commit ()
  {
    projektsystemDBAdm.commit();
  }
  // metode som sikrer endelig tilbageskrivning
  protected  static  void  close ()
  {
    projektsystemDBAdm.close();
  }

  
  // Projekt-collection controler og metode for tilgang
  private static ProjektAdministrator   projektAdministrator = new ProjektAdministrator (projektsystemDBAdm, "QProjekt");
  protected static ProjektAdministrator  getProjektAdministrator()
  {
    if (projektAdministrator==null)
      projektAdministrator = new ProjektAdministrator (projektsystemDBAdm, "QProjekt");
    return (projektAdministrator);
  }

  // Medarbejder-collection controler og metode for tilgang
  private static MedarbejderAdministrator   medarbejderAdministrator = new MedarbejderAdministrator (projektsystemDBAdm, "QMedarbejder");
  protected  static MedarbejderAdministrator  getMedarbejderAdministrator()
  {  
    if (medarbejderAdministrator==null)
      medarbejderAdministrator = new MedarbejderAdministrator (projektsystemDBAdm, "QMedarbejder");
    return (medarbejderAdministrator);
  }

  // Postdistrikt-collection controler og metode for tilgang
  private static PostdistriktAdministrator   postdistriktAdministrator = new PostdistriktAdministrator (projektsystemDBAdm, "QPostdistrikt");
  protected  static  PostdistriktAdministrator  getPostdistriktAdministrator()
  {    
    if (postdistriktAdministrator==null)
      postdistriktAdministrator = new PostdistriktAdministrator (projektsystemDBAdm, "QPostdistrikt");
    return (postdistriktAdministrator);
  }

  // Aktivitet-collection controler og metode for tilgang
  private static AktivitetAdministrator   aktivitetAdministrator = new AktivitetAdministrator (projektsystemDBAdm, "QAktivitet");
  protected  static  AktivitetAdministrator  getAktivitetAdministrator()
  {    
    if (aktivitetAdministrator==null)
      aktivitetAdministrator = new AktivitetAdministrator (projektsystemDBAdm, "QAktivitet");
    return (aktivitetAdministrator);
  }

  // Timeforbrug-collection controler og metode for tilgang
  private static TimeforbrugAdministrator   timeforbrugAdministrator = new TimeforbrugAdministrator (projektsystemDBAdm, "QTimeforbrug");
  protected  static  TimeforbrugAdministrator  getTimeforbrugAdministrator()
  {    
    if (timeforbrugAdministrator==null)
      timeforbrugAdministrator = new TimeforbrugAdministrator (projektsystemDBAdm, "QTimeforbrug");
    return (timeforbrugAdministrator);
  }


}




public class AktivitetAdministrator  extends DBObjectAdministrator  
  // Ekstra metoder

  // returner et nyt object - skal gemmes p databasen med add  
  // metoden er tilrettet 
  public  Aktivitet  newAktivitet (  String betegnelse, 
                                     Timestamp tildeltDato, 
                                     Medarbejder medarbejder, 
                                     Projekt projekt )
  {  
    ++lastKey;  
    Aktivitet aktivitet = new Aktivitet ( lastKey,
                                          betegnelse, 
                                          tildeltDato, 
                                          medarbejder, 
                                          projekt );
    return (aktivitet);  
  }  

  // returner aggregerede aktiviteter til projekt
  public Iterator iterator (Projekt projekt)
  {
    return iterator ("WHERE [ProjektID] = "+projekt.getID());
  }

  // returner associerede aktiviteter til medarbejder
  public Iterator iterator (Medarbejder medarbejder)
  {
    return iterator ("WHERE [MedarbejderID] = "+medarbejder.getID());
  }


}  



public class MedarbejderAdministrator  extends DBObjectAdministrator  

  // Ekstra metoder

  // returner et nyt object - skal gemmes p databasen med add  
  // metoden er tilrettet 
  public  Medarbejder  newMedarbejder (
                                     String fornavn, 
                                     String efternavn, 
                                     String gade, 
                                     String tlf, 
                                     Timestamp ansatDato, 
                                     Postdistrikt postdistrikt )
  {  
    ++lastKey;  
    Medarbejder medarbejder = new Medarbejder ( lastKey,
                               fornavn, 
                               efternavn, 
                               gade, 
                               tlf, 
                               ansatDato, 
                               postdistrikt );
    return (medarbejder);  
  }  

}  



public class PostdistriktAdministrator  extends DBObjectAdministrator  
{  

  // returner et nyt object - skal gemmes p databasen med add
  public  Postdistrikt  newPostdistrikt (int postnr, String distrikt )
  {
    Postdistrikt postdistrikt = new Postdistrikt ( postnr, distrikt );
    return (postdistrikt);
  }

}  



public class ProjektAdministrator  extends DBObjectAdministrator  
{  

  // Ekstra metoder

  // returner et nyt object - skal gemmes p databasen med add  
  // metoden er tilrettet 
  public  Projekt  newProjekt ( String betegnelse, 
                                Timestamp etableringsDato )
  {  
    ++lastKey;  
    Projekt projekt = new Projekt ( lastKey,
                                    betegnelse, 
                                    etableringsDato );
    return (projekt);  
  }  

}


public class TimeforbrugAdministrator  extends DBObjectAdministrator  
{  

  // Ekstra metoder

  // returner et nyt object - skal gemmes p databasen med add  
  // metoden er tilrettet 
  public  Timeforbrug  newTimeforbrug ( Timestamp dato, 
                                        float timer, 
                                        Aktivitet aktivitet )
  {  
    ++lastKey;  
    Timeforbrug timeforbrug = new Timeforbrug ( lastKey, dato, timer, aktivitet );
    return (timeforbrug);  
  }  

  // returner aggregerede timeforbrug til aktivitet
  public Iterator iterator (Aktivitet aktivitet)
  {
    return iterator ("WHERE [AktivitetID] = "+aktivitet.getID());
  }


}    



